// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/stripe.proto

package stripe

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "github.com/micro/micro/v3/service/api"
	client "github.com/micro/micro/v3/service/client"
	server "github.com/micro/micro/v3/service/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for Stripe service

func NewStripeEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for Stripe service

type StripeService interface {
	CreateCheckoutSession(ctx context.Context, in *CreateCheckoutSessionRequest, opts ...client.CallOption) (*CreateCheckoutSessionResponse, error)
	ListCards(ctx context.Context, in *ListCardsRequest, opts ...client.CallOption) (*ListCardsResponse, error)
	ChargeCard(ctx context.Context, in *ChargeCardRequest, opts ...client.CallOption) (*ChargeCardResponse, error)
	DeleteCard(ctx context.Context, in *DeleteCardRequest, opts ...client.CallOption) (*DeleteCardResponse, error)
	ListPayments(ctx context.Context, in *ListPaymentsRequest, opts ...client.CallOption) (*ListPaymentsResponse, error)
	GetPayment(ctx context.Context, in *GetPaymentRequest, opts ...client.CallOption) (*GetPaymentResponse, error)
	Subscribe(ctx context.Context, in *SubscribeRequest, opts ...client.CallOption) (*SubscribeResponse, error)
	Unsubscribe(ctx context.Context, in *UnsubscribeRequest, opts ...client.CallOption) (*UnsubscribeResponse, error)
	SetupCard(ctx context.Context, in *SetupCardRequest, opts ...client.CallOption) (*SetupCardResponse, error)
}

type stripeService struct {
	c    client.Client
	name string
}

func NewStripeService(name string, c client.Client) StripeService {
	return &stripeService{
		c:    c,
		name: name,
	}
}

func (c *stripeService) CreateCheckoutSession(ctx context.Context, in *CreateCheckoutSessionRequest, opts ...client.CallOption) (*CreateCheckoutSessionResponse, error) {
	req := c.c.NewRequest(c.name, "Stripe.CreateCheckoutSession", in)
	out := new(CreateCheckoutSessionResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stripeService) ListCards(ctx context.Context, in *ListCardsRequest, opts ...client.CallOption) (*ListCardsResponse, error) {
	req := c.c.NewRequest(c.name, "Stripe.ListCards", in)
	out := new(ListCardsResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stripeService) ChargeCard(ctx context.Context, in *ChargeCardRequest, opts ...client.CallOption) (*ChargeCardResponse, error) {
	req := c.c.NewRequest(c.name, "Stripe.ChargeCard", in)
	out := new(ChargeCardResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stripeService) DeleteCard(ctx context.Context, in *DeleteCardRequest, opts ...client.CallOption) (*DeleteCardResponse, error) {
	req := c.c.NewRequest(c.name, "Stripe.DeleteCard", in)
	out := new(DeleteCardResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stripeService) ListPayments(ctx context.Context, in *ListPaymentsRequest, opts ...client.CallOption) (*ListPaymentsResponse, error) {
	req := c.c.NewRequest(c.name, "Stripe.ListPayments", in)
	out := new(ListPaymentsResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stripeService) GetPayment(ctx context.Context, in *GetPaymentRequest, opts ...client.CallOption) (*GetPaymentResponse, error) {
	req := c.c.NewRequest(c.name, "Stripe.GetPayment", in)
	out := new(GetPaymentResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stripeService) Subscribe(ctx context.Context, in *SubscribeRequest, opts ...client.CallOption) (*SubscribeResponse, error) {
	req := c.c.NewRequest(c.name, "Stripe.Subscribe", in)
	out := new(SubscribeResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stripeService) Unsubscribe(ctx context.Context, in *UnsubscribeRequest, opts ...client.CallOption) (*UnsubscribeResponse, error) {
	req := c.c.NewRequest(c.name, "Stripe.Unsubscribe", in)
	out := new(UnsubscribeResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stripeService) SetupCard(ctx context.Context, in *SetupCardRequest, opts ...client.CallOption) (*SetupCardResponse, error) {
	req := c.c.NewRequest(c.name, "Stripe.SetupCard", in)
	out := new(SetupCardResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for Stripe service

type StripeHandler interface {
	CreateCheckoutSession(context.Context, *CreateCheckoutSessionRequest, *CreateCheckoutSessionResponse) error
	ListCards(context.Context, *ListCardsRequest, *ListCardsResponse) error
	ChargeCard(context.Context, *ChargeCardRequest, *ChargeCardResponse) error
	DeleteCard(context.Context, *DeleteCardRequest, *DeleteCardResponse) error
	ListPayments(context.Context, *ListPaymentsRequest, *ListPaymentsResponse) error
	GetPayment(context.Context, *GetPaymentRequest, *GetPaymentResponse) error
	Subscribe(context.Context, *SubscribeRequest, *SubscribeResponse) error
	Unsubscribe(context.Context, *UnsubscribeRequest, *UnsubscribeResponse) error
	SetupCard(context.Context, *SetupCardRequest, *SetupCardResponse) error
}

func RegisterStripeHandler(s server.Server, hdlr StripeHandler, opts ...server.HandlerOption) error {
	type stripe interface {
		CreateCheckoutSession(ctx context.Context, in *CreateCheckoutSessionRequest, out *CreateCheckoutSessionResponse) error
		ListCards(ctx context.Context, in *ListCardsRequest, out *ListCardsResponse) error
		ChargeCard(ctx context.Context, in *ChargeCardRequest, out *ChargeCardResponse) error
		DeleteCard(ctx context.Context, in *DeleteCardRequest, out *DeleteCardResponse) error
		ListPayments(ctx context.Context, in *ListPaymentsRequest, out *ListPaymentsResponse) error
		GetPayment(ctx context.Context, in *GetPaymentRequest, out *GetPaymentResponse) error
		Subscribe(ctx context.Context, in *SubscribeRequest, out *SubscribeResponse) error
		Unsubscribe(ctx context.Context, in *UnsubscribeRequest, out *UnsubscribeResponse) error
		SetupCard(ctx context.Context, in *SetupCardRequest, out *SetupCardResponse) error
	}
	type Stripe struct {
		stripe
	}
	h := &stripeHandler{hdlr}
	return s.Handle(s.NewHandler(&Stripe{h}, opts...))
}

type stripeHandler struct {
	StripeHandler
}

func (h *stripeHandler) CreateCheckoutSession(ctx context.Context, in *CreateCheckoutSessionRequest, out *CreateCheckoutSessionResponse) error {
	return h.StripeHandler.CreateCheckoutSession(ctx, in, out)
}

func (h *stripeHandler) ListCards(ctx context.Context, in *ListCardsRequest, out *ListCardsResponse) error {
	return h.StripeHandler.ListCards(ctx, in, out)
}

func (h *stripeHandler) ChargeCard(ctx context.Context, in *ChargeCardRequest, out *ChargeCardResponse) error {
	return h.StripeHandler.ChargeCard(ctx, in, out)
}

func (h *stripeHandler) DeleteCard(ctx context.Context, in *DeleteCardRequest, out *DeleteCardResponse) error {
	return h.StripeHandler.DeleteCard(ctx, in, out)
}

func (h *stripeHandler) ListPayments(ctx context.Context, in *ListPaymentsRequest, out *ListPaymentsResponse) error {
	return h.StripeHandler.ListPayments(ctx, in, out)
}

func (h *stripeHandler) GetPayment(ctx context.Context, in *GetPaymentRequest, out *GetPaymentResponse) error {
	return h.StripeHandler.GetPayment(ctx, in, out)
}

func (h *stripeHandler) Subscribe(ctx context.Context, in *SubscribeRequest, out *SubscribeResponse) error {
	return h.StripeHandler.Subscribe(ctx, in, out)
}

func (h *stripeHandler) Unsubscribe(ctx context.Context, in *UnsubscribeRequest, out *UnsubscribeResponse) error {
	return h.StripeHandler.Unsubscribe(ctx, in, out)
}

func (h *stripeHandler) SetupCard(ctx context.Context, in *SetupCardRequest, out *SetupCardResponse) error {
	return h.StripeHandler.SetupCard(ctx, in, out)
}
